package io.tesla.proviso.archive;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.compress.archivers.ArchiveEntry;
import org.apache.commons.compress.archivers.ArchiveOutputStream;
import org.apache.commons.compress.archivers.jar.JarArchiveEntry;

import com.google.common.io.ByteStreams;

public class CreateOperation implements ArchiveOperation {

  private Archive archive;
  private String location;
  private String resource;
  
  public CreateOperation(Archive archive, String location) {
    this.archive = archive;
    this.location = location;
  }
  
  public Archive with(String resource) {
    this.resource = resource;
    return archive;
  }

  public void run(ArchiveOutputStream aos) {
    System.out.println(location);
    ArchiveEntry ae = new JarArchiveEntry(location);
    try {
      InputStream is = new FileInputStream(new File(resource));
      aos.putArchiveEntry(ae);
      //ByteArrayOutputStream bos = new ByteArrayOutputStream();
      //System.out.println(is);
      ByteStreams.copy(is, aos);
      //bos.close();
      //aos.write(bos.toByteArray());
      aos.closeArchiveEntry();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }
}
