package io.tesla.proviso.archive;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.compress.archivers.ArchiveOutputStream;
import org.apache.commons.compress.archivers.jar.JarArchiveOutputStream;

public class DefaultArchive implements Archive {

  private File archive;
  private List<ArchiveOperation> operations;

  public DefaultArchive(File archive) {
    this.archive = archive;
    this.operations = new ArrayList<ArchiveOperation>();
  }

  public CreateOperation create(String location) {
    CreateOperation operation = new CreateOperation(this, location);
    operations.add(operation);
    return operation;
  }

  public ArchiveOperation update(String location) {
    return null;
  }

  public ArchiveOperation delete(String location) {
    return null;
  }

  public ArchiveOperation append(String resource) {
    return null;
  }

  public Archive filter(String resource) {
    return null;
  }

  public Archive write() throws ArchiveException {
        
    ArchiveOutputStream aos;
    try {
      aos = new JarArchiveOutputStream(new FileOutputStream(archive));
      for (ArchiveOperation operation : operations) {
        operation.run(aos);
      }
      aos.close();
    } catch (FileNotFoundException e) {
      throw new ArchiveException(e);
    } catch (IOException e) {
      throw new ArchiveException(e);
    }
    
    return this;
  }
}
